Misha and Grisha are funny boys, so they like to use new underground. The underground has n stations connected with n - 1 routes so that each route connects two stations, and it is possible to reach every station from any other.
The boys decided to have fun and came up with a plan. Namely, in some day in the morning Misha will ride the underground from station s to station f by the shortest path, and will draw with aerosol an ugly text "Misha was here" on every station he will pass through (including s and f). After that on the same day at evening Grisha will ride from station t to station f by the shortest path and will count stations with Misha's text. After that at night the underground workers will wash the texts out, because the underground should be clean.
The boys have already chosen three stations a, b and c for each of several following days, one of them should be station s on that day, another should be station f, and the remaining should be station t. They became interested how they should choose these stations s, f, t so that the number Grisha will count is as large as possible. They asked you for help.
The first line contains two integers n and q (2 ≤ n ≤ 105, 1 ≤ q ≤ 105) — the number of stations and the number of days.
The second line contains n - 1 integers p2, p3, ..., pn (1 ≤ pi ≤ n). The integer pi means that there is a route between stations pi and i. It is guaranteed that it's possible to reach every station from any other.
The next q lines contains three integers a, b and c each (1 ≤ a, b, c ≤ n) — the ids of stations chosen by boys for some day. Note that some of these ids could be same.
Print q lines. In the i-th of these lines print the maximum possible number Grisha can get counting when the stations s, t and f are chosen optimally from the three stations on the i-th day.
3 2
1 1
1 2 3
2 3 3
2 3
4 1
1 2 3
1 2 3
2
In the first example on the first day if s = 1, f = 2, t = 3, Misha would go on the route 1 2, and Grisha would go on the route 3
1
2. He would see the text at the stations 1 and 2. On the second day, if s = 3, f = 2, t = 3, both boys would go on the route 3
1
2. Grisha would see the text at 3 stations.
In the second examle if s = 1, f = 3, t = 2, Misha would go on the route 1 2
3, and Grisha would go on the route 2
3 and would see the text at both stations.
题目大意 给定一个有n个点的树,有m个询问,每个询问给出3个点,你需要分别选出一个点作为s,f,t,如果将s到f的路径上的所有点权加1,计算t到f的路径上的点权和,问可能的点权和最大为多少。
显然树链剖分。
枚举6种可能,然后取个max。然后水完了。
然而比赛最后30分钟发现这特么是道水题,早知道该先写D题(内心崩溃...)。然后最后30分钟内20分钟写了出来,然后gdb挂了。。
然后在没gdb的情况下,今天上午把它改出来(不可思议),然后发现,不会线段树区间lazy标记如何赋初值,树链剖分数组开始滥用。
另外线段树似乎容易被卡常,所以我就改用树状数组了(动态new点,能不TLE就怪了)。
(PS:其实这道题有一个很傻逼的$O(nlogn)$的做法,根本没必要树剖,直接求lca就行了,可惜当时没有想出来。。)
Code
/**
* Codeforces
* Problem#832D
* Accepted
* Time:1466ms
* Memory:14200k
*/
#include <iostream>
#include <cstdio>
#include <ctime>
#include <cmath>
#include <cctype>
#include <cstring>
#include <cstdlib>
#include <fstream>
#include <sstream>
#include <algorithm>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <vector>
#include <stack>
#ifndef WIN32
#define Auto "%lld"
#else
#define Auto "%I64d"
#endif
using namespace std;
typedef bool boolean;
const signed int inf = (signed)((1u << ) - );
const signed long long llf = (signed long long)((1ull << ) - );
const double eps = 1e-;
const int binary_limit = ;
#define smin(a, b) a = min(a, b)
#define smax(a, b) a = max(a, b)
#define max3(a, b, c) max(a, max(b, c))
#define min3(a, b, c) min(a, min(b, c))
template<typename T>
inline boolean readInteger(T& u){
char x;
int aFlag = ;
while(!isdigit((x = getchar())) && x != '-' && x != -);
if(x == -) {
ungetc(x, stdin);
return false;
}
if(x == '-'){
x = getchar();
aFlag = -;
}
for(u = x - ''; isdigit((x = getchar())); u = (u << ) + (u << ) + x - '');
ungetc(x, stdin);
u *= aFlag;
return true;
} #define LL int
#define lowbit(x) (x & (-x)) typedef class IndexedTree {
public:
LL* a;
int s;
IndexedTree():a(NULL), s() { }
IndexedTree(int n):s(n) {
a = new LL[(n + )];
memset(a, , sizeof(LL) * (n + ));
} inline void add(int idx, LL val) {
for(; idx <= s; idx += lowbit(idx))
a[idx] += val;
} inline LL getSum(int idx) {
LL rt = ;
for(; idx; idx -= lowbit(idx))
rt += a[idx];
return rt;
}
}IndexedTree; typedef class SegmentableIndexedTree {
public:
IndexedTree s; // sum
IndexedTree us; // unique sum
stack< pair<int, int> > bs; SegmentableIndexedTree() { }
SegmentableIndexedTree(int n) {
s = IndexedTree(n + );
us = IndexedTree(n + );
} inline void add(int l, int r, LL val) {
s.add(l, val), us.add(l, l * val);
s.add(r + , -val), us.add(r + , -(r + ) * val);
if(val > )
bs.push(pair<int, int>(l, r));
} inline LL getSum(int idx) {
return (idx + ) * s.getSum(idx) - us.getSum(idx);
} inline LL getSum(int l, int r) {
return getSum(r) - getSum(l - );
} inline void reset() {
pair<int, int> p;
while(!bs.empty()) {
p = bs.top();
bs.pop();
add(p.first, p.second, -);
}
}
}SegmentableIndexedTree; const int maxn = 1e5 + ;
int n, m;
vector<int> g[maxn]; inline void init() {
readInteger(n);
readInteger(m);
for(int i = , x; i < n; i++) {
readInteger(x);
g[x].push_back(i + );
}
} int cnt = ;
int visitID[maxn], size[maxn], fa[maxn];
int zson[maxn], dep[maxn], top[maxn];
SegmentableIndexedTree st; void dfs1(int node, int last) {
dep[node] = dep[last] + ;
size[node] = ;
fa[node] = last;
int maxs = , maxid = ;
for(int i = ; i < (signed)g[node].size(); i++) {
int& e = g[node][i];
if(e == last) continue;
dfs1(e, node);
size[node] += size[e];
if(size[e] > maxs) maxs = size[e], maxid = e;//if(siz[son[u]] < siz[v]) son[u] = v;
}
zson[node] = maxid;
} void dfs2(int node, int last, boolean iszson) {
top[node] = (iszson) ? (top[last]) : (node);
visitID[node] = ++cnt;
if(zson[node] != ) dfs2(zson[node], node, true);
for(int i = ; i < (signed)g[node].size(); i++) {
int& e = g[node][i];
if(e == last || e == zson[node]) continue;
dfs2(e, node, false);
}
} void update(int a, int b){
// cout << st.query(st.root, 1, n, 1, n) << endl;
while(top[a] != top[b]){
int& d = (dep[top[a]] > dep[top[b]]) ? (a) : (b);
st.add(visitID[top[d]], visitID[d], );
d = fa[top[d]];
}
if(visitID[a] > visitID[b]) swap(a, b);
st.add(visitID[a], visitID[b], );
// cout << st.query(st.root, 1, n, 1, n) << endl;
} int query(int a, int b) {
int ret = ;
while(top[a] != top[b]){
int& d = (dep[top[a]] > dep[top[b]]) ? (a) : (b);
ret += st.getSum(visitID[top[d]], visitID[d]);
d = fa[top[d]];
}
if(visitID[a] > visitID[b]) swap(a, b);
ret += st.getSum(visitID[a], visitID[b]);
// cout << ret << endl;
// cout << "============================" << endl;
return ret;
} int query(int s, int t, int f) {
st.reset();
update(s, f);
return query(t, f);
} inline void solve() {
int a, b, c;
dfs1(, );
dfs2(, , false);
st = SegmentableIndexedTree(n);
// for(int i = 1; i <= n; i++)
// cout << zson[i] << " ";
while(m--) {
readInteger(a);
readInteger(b);
readInteger(c);
int res = query(a, b, c);
smax(res, query(b, a, c));
smax(res, query(b, c, a));
smax(res, query(b, a, c));
smax(res, query(c, a, b));
smax(res, query(c, b, a));
printf("%d\n", res);
}
} int main() {
init();
solve();
return ;
}
/**
* Codeforces
* Problem#832D
* Accepted
* Time:1466ms
* Memory:14200k
*/
#include <iostream>
#include <cstdio>
#include <ctime>
#include <cmath>
#include <cctype>
#include <cstring>
#include <cstdlib>
#include <fstream>
#include <sstream>
#include <algorithm>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <vector>
#include <stack>
#ifndef WIN32
#define Auto "%lld"
#else
#define Auto "%I64d"
#endif
using namespace std;
typedef bool boolean;
const signed int inf = (signed)((1u << ) - );
const signed long long llf = (signed long long)((1ull << ) - );
const double eps = 1e-;
const int binary_limit = ;
#define smin(a, b) a = min(a, b)
#define smax(a, b) a = max(a, b)
#define max3(a, b, c) max(a, max(b, c))
#define min3(a, b, c) min(a, min(b, c))
template<typename T>
inline boolean readInteger(T& u){
char x;
int aFlag = ;
while(!isdigit((x = getchar())) && x != '-' && x != -);
if(x == -) {
ungetc(x, stdin);
return false;
}
if(x == '-'){
x = getchar();
aFlag = -;
}
for(u = x - ''; isdigit((x = getchar())); u = (u << ) + (u << ) + x - '');
ungetc(x, stdin);
u *= aFlag;
return true;
} #define LL int
#define lowbit(x) (x & (-x)) typedef class IndexedTree {
public:
LL* a;
int s;
IndexedTree():a(NULL), s() { }
IndexedTree(int n):s(n) {
a = new LL[(n + )];
memset(a, , sizeof(LL) * (n + ));
} inline void add(int idx, LL val) {
for(; idx <= s; idx += lowbit(idx))
a[idx] += val;
} inline LL getSum(int idx) {
LL rt = ;
for(; idx; idx -= lowbit(idx))
rt += a[idx];
return rt;
}
}IndexedTree; typedef class SegmentableIndexedTree {
public:
IndexedTree s; // sum
IndexedTree us; // unique sum
stack< pair<int, int> > bs; SegmentableIndexedTree() { }
SegmentableIndexedTree(int n) {
s = IndexedTree(n + );
us = IndexedTree(n + );
} inline void add(int l, int r, LL val) {
s.add(l, val), us.add(l, l * val);
s.add(r + , -val), us.add(r + , -(r + ) * val);
if(val > )
bs.push(pair<int, int>(l, r));
} inline LL getSum(int idx) {
return (idx + ) * s.getSum(idx) - us.getSum(idx);
} inline LL getSum(int l, int r) {
return getSum(r) - getSum(l - );
} inline void reset() {
pair<int, int> p;
while(!bs.empty()) {
p = bs.top();
bs.pop();
add(p.first, p.second, -);
}
}
}SegmentableIndexedTree; const int maxn = 1e5 + ;
int n, m;
vector<int> g[maxn]; inline void init() {
readInteger(n);
readInteger(m);
for(int i = , x; i < n; i++) {
readInteger(x);
g[x].push_back(i + );
}
} int cnt = ;
int visitID[maxn], size[maxn], fa[maxn];
int zson[maxn], dep[maxn], top[maxn];
SegmentableIndexedTree st; void dfs1(int node, int last) {
dep[node] = dep[last] + ;
size[node] = ;
fa[node] = last;
int maxs = , maxid = ;
for(int i = ; i < (signed)g[node].size(); i++) {
int& e = g[node][i];
if(e == last) continue;
dfs1(e, node);
size[node] += size[e];
if(size[e] > maxs) maxs = size[e], maxid = e;//if(siz[son[u]] < siz[v]) son[u] = v;
}
zson[node] = maxid;
} void dfs2(int node, int last, boolean iszson) {
top[node] = (iszson) ? (top[last]) : (node);
visitID[node] = ++cnt;
if(zson[node] != ) dfs2(zson[node], node, true);
for(int i = ; i < (signed)g[node].size(); i++) {
int& e = g[node][i];
if(e == last || e == zson[node]) continue;
dfs2(e, node, false);
}
} void update(int a, int b){
// cout << st.query(st.root, 1, n, 1, n) << endl;
while(top[a] != top[b]){
int& d = (dep[top[a]] > dep[top[b]]) ? (a) : (b);
st.add(visitID[top[d]], visitID[d], );
d = fa[top[d]];
}
if(visitID[a] > visitID[b]) swap(a, b);
st.add(visitID[a], visitID[b], );
// cout << st.query(st.root, 1, n, 1, n) << endl;
} int query(int a, int b) {
int ret = ;
while(top[a] != top[b]){
int& d = (dep[top[a]] > dep[top[b]]) ? (a) : (b);
ret += st.getSum(visitID[top[d]], visitID[d]);
d = fa[top[d]];
}
if(visitID[a] > visitID[b]) swap(a, b);
ret += st.getSum(visitID[a], visitID[b]);
// cout << ret << endl;
// cout << "============================" << endl;
return ret;
} int query(int s, int t, int f) {
st.reset();
update(s, f);
return query(t, f);
} inline void solve() {
int a, b, c;
dfs1(, );
dfs2(, , false);
st = SegmentableIndexedTree(n);
// for(int i = 1; i <= n; i++)
// cout << zson[i] << " ";
while(m--) {
readInteger(a);
readInteger(b);
readInteger(c);
int res = query(a, b, c);
smax(res, query(b, a, c));
smax(res, query(b, c, a));
smax(res, query(b, a, c));
smax(res, query(c, a, b));
smax(res, query(c, b, a));
printf("%d\n", res);
}
} int main() {
init();
solve();
return ;
}